﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private nativeMe As JavaObject
	
End Sub
'Initializes the object.
Public Sub Initialize
	nativeMe = Me
End Sub

'Returns an Array of integers sorted in Decending order
'Example:
'
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim aa(100) As Int
'For i = 0 To 99
' aa(i) = Rnd(0,1000)
'  Log(aa(i))
'Next
'aa = mymath.BubbleSortDecending(aa)
'For i = 0 To 99
'  Log(aa(i))
'Next
Public Sub BubbleSortDecending(intsToSort() As Int) As Int()

intsToSort = nativeMe.RunMethod("BubbleSortDecending",Array(intsToSort))
Return intsToSort

End Sub
'Returns an Array of integers sorted in Ascending order
'Example:
'
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim aa(100) As Int
'For i = 0 To 99
' aa(i) = Rnd(0,1000)
'  Log(aa(i))
'Next
'aa = mymath.BubbleSortAscending(aa)
'For i = 0 To 99
'  Log(aa(i))
'Next
Public Sub BubbleSortAscending(intsToSort() As Int) As Int()

intsToSort = nativeMe.RunMethod("BubbleSortAscending",Array(intsToSort))
Return intsToSort

End Sub
'Test an integer for being a prime number
'Example
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim numb as Int = 2
'Log("Is Prime = " & mmu.isPrime(numb))
Public Sub isPrime (n As Int) As Boolean
Dim testPrime As Boolean
testPrime = nativeMe.RunMethod("isPrime",Array(n))
Return testPrime

End Sub

'Sorts an Array of Double from smallest To largest
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim myarray(5) As Double
'myarray(0) = 12.3
'myarray(1) = 12.2
'myarray(2) = 12.9
'myarray(3) = 12.66
'myarray(4)= 12.615
'myarray = mmu.sortArrayOfDoublesFromSmallToLarge(myarray)	
'For i = 0 To myarray.Length-1
'  Log(myarray(i))
'Next  
Public Sub sortArrayOfDoublesFromSmallToLarge (n() As Double) As Double()

n = nativeMe.RunMethod("sortArrayOfDoublesFromSmallToLarge",Array(n))
Return n

End Sub
'Sorts an Array of Double from largest To smallest
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim myarray(5) As Double
'myarray(0) = 12.3
'myarray(1) = 12.2
'myarray(2) = 12.9
'myarray(3) = 12.66
'myarray(4)= 12.615
'myarray = mmu.sortArrayOfDoublesFromLargeToSmall(myarray)	
'For i = 0 To myarray.Length-1
'  Log(myarray(i))
'Next  
Public Sub sortArrayOfDoublesFromLargeToSmall (n() As Double) As Double()

n = nativeMe.RunMethod("sortArrayOfDoublesFromLargeToSmall",Array(n))
Return n

End Sub
'Converts an integer number to a hexadecimal number.
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim num As Int = 12345
'log (mmu.ConvertIntToHex(num))
Public Sub ConvertIntToHex (n As Int) As String

Dim intToHex As String
intToHex = nativeMe.RunMethod("ConvertIntToHex",Array(n))
Return intToHex

End Sub
'Converts an integer number to a octal number.
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim num As Int = 12345
'log (mmu.ConvertIntToOct(num))
Public Sub ConvertIntToOct(n As Int) As String

Dim intToOct As String
intToOct = nativeMe.RunMethod("ConvertIntToOct",Array(n))
Return intToOct

End Sub
'Converts an integer number to a binary number.
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim num As Int = 12345
'log (mmu.ConvertIntToBin(num))
Public Sub ConvertIntToBin(n As Int) As String

Dim intToBin As String
intToBin = nativeMe.RunMethod("ConvertIntToBin",Array(n))
Return intToBin

End Sub

'Get the factorial of an integer number
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim num As Int = 6
'log (mmu.getFactorial(num))
Public Sub getFactorial(n As Int) As Int

Dim fact As Int = 0
fact = nativeMe.RunMethod("getFactorial",Array(n))
Return fact

End Sub
'Calculate the distance (in nautical miles) between two geographical points
'by using the law of cosines (pass values as decimal degrees).
'East Longitude is +, West Longitude is -
'North Latitude is +, South Latitude is -
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim myDistance As Double
'myDistance = mmu.locGreatCircleNm(-29-(53/60), 31+(3/60), -29-(6/60), 26+(13/60))
Public Sub locGreatCircleNm(lat1 As Double, long1 As Double, lat2 As Double, long2 As Double) As Double

Dim distance As Double = 0.0
distance = nativeMe.RunMethod("locGreatCircleNm",Array(lat1, long1, lat2, long2))
Return distance

End Sub
'Calculate the distance (in nautical miles) between two geographical points
'by using the Haversine Formula (pass values As decimal degrees).
'East Longitude is +, West Longitude is -
'North Latitude is +, South Latitude is -
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim myDistance As Double
'myDistance = mmu.hsGreatCircleNm(-29-(53/60), 31+(3/60), -29-(6/60), 26+(13/60))
Public Sub hsGreatCircleNm(lat1 As Double, long1 As Double, lat2 As Double, long2 As Double) As Double

Dim distance As Double = 0.0
distance = nativeMe.RunMethod("hsGreatCircleNm",Array(lat1, long1, lat2, long2))
Return distance

End Sub

'Calculate the distance (in kilometers) between two geographical points
'by using the Haversine Formula (pass values As decimal degrees).
'East Longitude is +, West Longitude is -
'North Latitude is +, South Latitude is -
'Example:
'Dim mmu as MathUtilities
'mmu.Initialize
'Dim myDistance As Double
'myDistance = mmu.hsGreatCircleKm(-29-(53/60), 31+(3/60), -29-(6/60), 26+(13/60))
Public Sub hsGreatCircleKm(lat1 As Double, long1 As Double, lat2 As Double, long2 As Double) As Double

Dim distance As Double = 0.0
distance = nativeMe.RunMethod("hsGreatCircleKm",Array(lat1, long1, lat2, long2))
Return distance

End Sub


#If Java

import java.util.*; 
import java.text.DateFormat; 
import java.text.SimpleDateFormat; 

/**
* Sort an array of Double from smallest to largest
*Example:<code>
*Dim myarray(5) As Double
*myarray(0) = 12.3
*myarray(1) = 12.2
*myarray(2) = 12.9
*myarray(3) = 12.66
*myarray(4)= 12.615
*myarray = mymath.sortarray(myarray)</code>
*/
public double[] sortArrayOfDoublesFromSmallToLarge(double[] value) { 
  for (int arrayIterator = 0; arrayIterator < value.length; arrayIterator++) { 
    for(int iterator2=arrayIterator+1;iterator2<value.length;iterator2++){ 
      if(value[iterator2]<value[arrayIterator]){ 
        double temp=value[arrayIterator]; 
        value[arrayIterator]=value[iterator2]; 
        value[iterator2]=temp; 
      } 
    } 
  } 
  return value; 
} 

/**
* Sort an array of Double from largest to smallest
*Example:<code>
*Dim myarray(5) As Double
*myarray(0) = 12.3
*myarray(1) = 12.2
*myarray(2) = 12.9
*myarray(3) = 12.66
*myarray(4)= 12.615
*myarray = mymath.sortarray(myarray)</code>
*/
public double[] sortArrayOfDoublesFromLargeToSmall(double[] value) { 
  for (int arrayIterator = 0; arrayIterator < value.length; arrayIterator++) { 
    for(int iterator2=arrayIterator+1;iterator2<value.length;iterator2++){ 
      if(value[iterator2]>value[arrayIterator]){ 
        double temp=value[arrayIterator]; 
        value[arrayIterator]=value[iterator2]; 
        value[iterator2]=temp; 
      } 
    } 
  } 
  return value; 
} 


/**
* Converts an integer number to a hexadecimal number.
*Example:<code>
*Dim mystring As String
*Dim num as Int = 123456
*mystring = mymath.ConvertIntToHex(num)
</code>
*/
public String ConvertIntToHex (int number) {
  String bin;
  int waarde; 
  waarde = number;	
  bin = "";
   
  bin = Integer.toHexString(waarde).toUpperCase(); 
  return bin;
}


/**
* Converts an integer number to an octal number.
*Example:<code>
*Dim mystring As String
*Dim num as Int = 123456
*mystring = mymath.ConvertIntToOct(num)
</code>
*/
public String ConvertIntToOct (int number) {
  String bin;
  int waarde; 
  waarde = number;	
  bin = "";
   
  bin = Integer.toOctalString(waarde); 
  return bin;
}

/**
* Converts an integer number to a binary number.
*Example:<code>
*Dim mystring As String
*Dim num as Int = 255
*mystring = mymath.ConvertIntToBin(num)
</code>
*/
public String ConvertIntToBin (int number) {
  String bin;
  int waarde; 
  waarde = number;	
  bin = "";
  bin = Integer.toBinaryString(waarde); 
  return bin;
}


/**
* Calculate and return the factorial of an Integer number
*Example:<code>
*Dim myval As Int
*myval = mymath.Factorial(6)</code>
*/
public int getFactorial (int calcFactorial)  {
  int n, c, fact = 1; 
  n = calcFactorial; 
  if ( n != 0 )  { 
    for ( c = 1 ; c <= n ; c++ ) {
      fact = fact*c; 
    }
  } 
  return fact;
}

/**
* Test an integer number for it being a Prime number
*Example:<code>
*Dim myboolean As Boolean
*myboolean = mymath.isPrime(17)</code>
*/
public boolean isPrime(int n) { 
  //check if n is a multiple of 2 
  if (n==1) return true;
  if (n==2) return true;
  if (n%2==0) return false; 
  //if not, then just check the odds 
  for(int i=3;i*i<=n;i+=2) {
    if(n%i==0) 
       return false;
  } 
  return true; 
}

/**
*Calculate the distance (in nautical miles) between two geographical points
*by using the law of cosines (pass values as decimal degrees).
*East Longitude is +, West Longitude is -
*North Latitude is +, South Latitude is -
*Example:<code>
*Dim myDistance As Double
*myDistance = mymath.locGreatCircleNm(59.9, -30.3, 37.8, 122.4)</code>
*/
public double locGreatCircleNm(double lat1, double long1, double lat2, double long2) { 

        double x1 = Math.toRadians(lat1);
        double y1 = Math.toRadians(long1);
        double x2 = Math.toRadians(lat2);
        double y2 = Math.toRadians(long2);

       /*************************************************************************
        * Compute using law of cosines
        *************************************************************************/
        // great circle distance in radians
        double angle1 = Math.acos(Math.sin(x1) * Math.sin(x2)
                      + Math.cos(x1) * Math.cos(x2) * Math.cos(y1 - y2));

        // convert back to degrees
        angle1 = Math.toDegrees(angle1);

        // each degree on a great circle of Earth is 60 nautical miles
        double distance1 = 60 * angle1;

        return distance1;
}

/**
*Calculate the distance (in nautical miles) between two geographical points
*by using the Haversine Formula (pass values as decimal degrees).
*East Longitude is +, West Longitude is -
*North Latitude is +, South Latitude is -
*Example:<code>
*Dim myDistance As Double
*myDistance = mymath.hsGreatCircleNm(40.35, 74.65, 48.87, -2.33)</code>
*/
public double hsGreatCircleNm(double lat1, double long1, double lat2, double long2) { 

        double x1 = Math.toRadians(lat1);
        double y1 = Math.toRadians(long1);
        double x2 = Math.toRadians(lat2);
        double y2 = Math.toRadians(long2);


       /*************************************************************************
        * Compute using Haversine formula
        *************************************************************************/
        double a = Math.pow(Math.sin((x2-x1)/2), 2)
                 + Math.cos(x1) * Math.cos(x2) * Math.pow(Math.sin((y2-y1)/2), 2);

        // great circle distance in radians
        double angle2 = 2 * Math.asin(Math.min(1, Math.sqrt(a)));

        // convert back to degrees
        angle2 = Math.toDegrees(angle2);

        // each degree on a great circle of Earth is 60 nautical miles
        double distance2 = 60 * angle2;

       return distance2;
}

/**
*Calculate the distance (in kilometers) between two geographical points
*by using the Haversine Formula (pass values as decimal degrees).
*East Longitude is +, West Longitude is -
*North Latitude is +, South Latitude is -
*Example:<code>
*Dim myDistance As Double
*myDistance = mymath.hsGreatCircleKm(40.35, 74.65, 48.87, -2.33)</code>
*/
public double hsGreatCircleKm(double lat1, double long1, double lat2, double long2) { 
    double R = 6372.8; // In kilometers
    double dLat = Math.toRadians(lat2 - lat1);
    double dLon = Math.toRadians(long2 - long1);
    lat1 = Math.toRadians(lat1);
    lat2 = Math.toRadians(lat2);

    double a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.sin(dLon / 2) * Math.sin(dLon / 2) * Math.cos(lat1) * Math.cos(lat2);
    double c = 2 * Math.asin(Math.sqrt(a));
    return R * c;
}


public int[] BubbleSortAscending(int[] intsToSort) {
    int n, c, d, swap;
    n = intsToSort.length;
 
    for (c = 0; c < ( n - 1 ); c++) {
      for (d = 0; d < n - c - 1; d++) {
        if (intsToSort[d] > intsToSort[d+1]) 
        {
          swap = intsToSort[d];
          intsToSort[d] = intsToSort[d+1];
          intsToSort[d+1] = swap;
        }
      }
    }
   return intsToSort;
}


public int[] BubbleSortDecending(int[] intsToSort) {
    int n, c, d, swap;
    n = intsToSort.length;
 
    for (c = 0; c < ( n - 1 ); c++) {
      for (d = 0; d < n - c - 1; d++) {
        if (intsToSort[d] < intsToSort[d+1]) 
        {
          swap = intsToSort[d];
          intsToSort[d] = intsToSort[d+1];
          intsToSort[d+1] = swap;
        }
      }
    }
   return intsToSort;
}



#End If